# Certifikáty Let's Encrypt v prostředí FI MU

## Potřebuji tohle?

Možná ne :-). Certifikační autorita [Let's Encrypt](https://letsencrypt.org)
je přístupná komukoli.
Jedna z možností tedy je celé to nastudovat, zprovoznit některého klienta
a řídit si vystavování a obnovování certifikátů ve vlastní režii, bez
spolupráce `unix@fi`.

Druhou možností je pořídit si certifikát TERENA, který má univerzita zdarma
přes CESNET. Oproti Let's Encrypt je to o něco víc byrokracie, ale zase vydávají
certifikáty s platností na dva roky (LE jen na tři měsíce).

Certifikát od LE je získatelný s menší byrokracií
a část práce s vystavením a obnovováním certifikátů může převzít `unix@fi`
za pomoci zde přístupných skriptů.

## Chci certifikát! Jak na to?

Příklad: potřebuji certifikát pro svůj nový projekt `https://zverinec.cz`, který
chci provozovat na svém serveru `zoo.fi.muni.cz` (projekt a server
ale nemusí nutně mít různá jména, může jít o totéž).

* Na počítači, kde tento projekt má běžet, zkonfigurujte a spusťte HTTP server,
například Apache (HTTPS zatím ne, nemáte certifikát). Ujistěte se se,
že po zadání (`http://zverinec.cz/`) do prohlížeče dostanete stránku ze svého
serveru.

* Zkopírujte si na svůj server tento repozitář:

```shell
    git clone https://gitlab.fi.muni.cz/unix/letsencrypt-fi.git
```

* Zkontrolujte, že na počítači jsou nainstalované balíky `openssl` a `perl`.

* Vygenerujte tajný klíč a certificate request skriptem
`./le-gen-csr zverinec.cz`. Výstupem tohoto skriptu jsou tři soubory:

  * `zverinec.cz.key` - tajný klíč, který nikomu nedávejte. Zkopírujte jej do příslušného systémového adresáře (na RHEL/CentOS/Fedoře do `/etc/pki/tls/private/`, na Debianu/Ubuntu do `/etc/ssl/private/`).
  * `zverinec.cz.crt` - dočasný self-signed certifikát, určený k tomu, abyste si mohli všechno nakonfigurovat a nemuseli čekat na vystavení "ostrého" certifikátu.
I tento umístěte do příslušného systémového adresáře, například do `/etc/pki/tls/certs/` nebo `/etc/ssl/certs/`.
  * `zverinec.cz.csr` - certificate request. Na základě tohoto vystaví LE skutečný certifikát.

* Nakonfigurujte HTTPS server tak, aby používal výše uvedený klíč a certifikát.
Pro Apache 2.4 můžete použít tyto direktivy v souboru `httpd.conf`:

```
    SSLCertificateFile /etc/pki/tls/certs/zverinec.cz.crt
    SSLCertificateKeyFile /etc/pki/tls/private/zverinec.cz.key
```

* Ověřte si úroveň bezpečnosti konfigurace SSL, například dle návodu na <https://www.fi.muni.cz/tech/unix/ssl-apache.xhtml> (zakázání slabých šifer, zranitelných protokolů a podobně).

* Nainstalujte skripty `le-acme-put-token` a `le-renewed-cert` do systémových
adresářů a povolte k nim přístup přes SSH z počítače `thetis.fi.muni.cz`:

```shell
    cp le-acme-put-token le-renewed-cert /usr/local/sbin/
    cat letsencrypt-fi-authorized-keys >> /root/.ssh/authorized_keys
```

* V obou skriptech je na začátku konfigurace, kde můžete upravit například
jiné umístění souboru s certifikáty, stromu webových stránek nebo příkazu
pro znovunačtení konfigurace HTTPS serveru.

* Nyní už zbývá jen požádat `unix@fi` o vystavení certifikátu. K žádosti přiložte
dříve vygenerovaný certificate request - soubor `zverinec.cz.csr`:

> Prosím o vygenerování a průběžnou aktualizaci certifikátu Let's Encrypt
> pro můj projekt `zverinec.cz`.
> Skripty z gitlab repozitáře `unix/letsencrypt-fi`
> jsou přístupné přes SSH na uživatele `root@zoo.fi.muni.cz`.
> Přikládám certificate request.
> Kontaktní adresa na správce tohoto projektu je `zverinec-devel@fi.muni.cz`.

* Poté `unix@fi` zajistí vystavení certifikátu a již pomocí nainstalovaných skriptů přes SSH se certifikát dostane na váš server.

* Skripty samozřejmě můžete zkoumat a upravovat dle libosti.

## Dotazy, připomínky

Máte-li dotazy nebo potřebujete-li ještě něco trochu jiného, než je zde popsáno,
neváhejte se obrátit na `unix@fi.muni.cz`.